com.sun.messaging.jms

## Interface Message

    public interface Message

The `com.sun.messaging.jms.Message` interface defines enhanced capabilities of a JMS Message in Oracle GlassFish(tm) Server Message Queue.

It defines

- Additional methods available for custom message acknowledgement behavior.

See Also:
  `Message`

### Method Summary

Methods
`void` `acknowledgeThisMessage()` Acknowledges this consumed message only.
`void` `acknowledgeUpThroughThisMessage()` Acknowledges consumed messages of the session up through and including this consumed message.

### Method Detail

#### acknowledgeThisMessage

    void acknowledgeThisMessage()
                                throws JMSException

Acknowledges this consumed message only.

All consumed JMS messages in Oracle GlassFish(tm) Server Message Queue support the `acknowledgeThisMessage` method for use when a client has specified that its JMS session's consumed messages are to be explicitly acknowledged. By invoking `acknowledgeThisMessage` on a consumed message, a client acknowledges only the specific message that the method is invoked on.

Calls to `acknowledgeThisMessage` are ignored for both transacted sessions and sessions specified to use implicit acknowledgement modes.

Throws:
  `JMSException` - if the messages fail to get acknowledged due to an internal error.
  `IllegalStateException` - if this method is called on a closed session.
See Also:
  `Session.CLIENT_ACKNOWLEDGE`, `javax.jms.Message.acknowledge()`, `acknowledgeUpThroughThisMessage()`

#### acknowledgeUpThroughThisMessage

    void acknowledgeUpThroughThisMessage()
                                         throws JMSException

Acknowledges consumed messages of the session up through and including this consumed message.

All consumed JMS messages in Oracle GlassFish(tm) Server Message Queue support the `acknowledgeUpThroughThisMessage` method for use when a client has specified that its JMS session's consumed messages are to be explicitly acknowledged. By invoking `acknowledgeUpThroughThisMessage` on a consumed message, a client acknowledges messages starting with the first unacknowledged message and ending with this message that were consumed by the session that this message was delivered to.

Calls to `acknowledgeUpThroughThisMessage` are ignored for both transacted sessions and sessions specified to use implicit acknowledgement modes.

Throws:
  `JMSException` - if the messages fail to get acknowledged due to an internal error.
  `IllegalStateException` - if this method is called on a closed session.
See Also:
  `Session.CLIENT_ACKNOWLEDGE`, `javax.jms.Message.acknowledge()`, `acknowledgeThisMessage()`